<template>
  <v-container>
    <page-content>
      <div>
        <v-col v-if="step==1" cols="12" md="auto">
          <p class="headline">
            Registrar nueva compañía cliente
          </p>
        </v-col>
        <v-col v-else-if="step==2" cols="12" md="auto">
          <p class="headline">
            Registrar supervisor
          </p>
        </v-col>
        <stepper :step="step">
          <template slot="step-items">
            <v-stepper-content step="1" class="pa-0">
              <v-container>
                <register-clients @clickButton="goToStep2" />
              </v-container>
            </v-stepper-content>
            <v-stepper-content step="2" class="pa-0">
              <v-container>
                <v-card flat>
                  <confirmation-modal
                    :is-open="openModal"
                    :modal-text="modalText"
                    @confirm="registerClientSupervisorConfirm"
                    @cancel="cancelRegister"
                  />
                  <register-client-supervisor @regresar="goToStep1" @registerSupervisor="handleRegister" />
                </v-card>
              </v-container>
            </v-stepper-content>
          </template>
        </stepper>
      </div>
    </page-content>
  </v-container>
</template>

<script>
import { mapActions, mapState } from 'vuex';
import ConfirmationModal from '~/components/register/confirmationModal';
import RegisterClientSupervisor from '~/components/ClientSupervisor/RegisterClientSupervisor';
import Stepper from '~/components/Steppers/Stepper.vue';
import RegisterClients from '~/components/Clients/RegisterClients';

export default {
  name: 'NuevoCliente',
  components: {
    ConfirmationModal,
    Stepper,
    RegisterClientSupervisor,
    RegisterClients,
  },
  data() {
    return {
      tab: 0,
      step: 1,
      valid: true,
      modalText: '¿Estás seguro que deseas guardar los cambios?',
      openModal: false,
    };
  },
  computed: {
    ...mapState({
      newClientSupervisor: state => state.['client-supervisor'].newClientSupervisor,
      newClientCompany: state => state.providercompany['client-company'].newClientCompany,
      checkedClientSupervisor: state => state.['client-supervisor'].checkedClientSupervisor,
    }),
  },
  methods: {
    ...mapActions({
      // getCompanies: 'providercompany/client-company/getClientCompanies',
      registerClientCompany: 'providercompany/client-company/registerClientCompany',
      getNewClientCompany: 'providercompany/client-company/getNewClientCompany',
      saveClientSupervisor: 'client-supervisor/saveClientSupervisor',
    }),
    async confirmRegister() {
      // await this.registerClientCompanies();
      // await this.getCompanies();
      await this.$router.push('/clientes');
    },
    goToStep2() {
      console.log('go to step 2');
      this.step = 2;
    },
    goToStep1() {
      console.log(this.tab);
      this.step = 1;
    },
    handleRegister() {
      this.openModal = true;
    },
    cancelRegister() {
      this.openModal = false;
    },
    // When finish 1st and 2nd step (Register Individual)
    async registerClientSupervisorConfirm() {
      // Register client company and client supervisor in BD.
      const company = await this.registerClientCompany(this.newClientCompany);
      const formData = new FormData();
      formData.append('clientCompanyId', company.data.id);
      formData.append('document', this.newClientSupervisor.document);
      formData.append('typeDocument', this.newClientSupervisor.typeDocument);
      formData.append('name', this.newClientSupervisor.name);
      formData.append('fatherLastname', this.newClientSupervisor.fatherLastname);
      formData.append('motherLastname', this.newClientSupervisor.motherLastname);
      formData.append('email', this.newClientSupervisor.email);
      formData.append('phoneNumber', this.newClientSupervisor.phoneNumber);
      formData.append('address', this.newClientSupervisor.address);
      console.log(this.newClientSupervisor);
      // ONLY in the case that the image is null send it.
      if (this.newClientSupervisor.image != null) {
        formData.append('multipartFile', this.newClientSupervisor.image);
      }

      await this.saveClientSupervisor({ supervisor: formData });
      await this.$router.push('/clientes');
    },
  },
};
</script>
